#!/usr/bin/php5
<?php
// early alpha     kner 2015, 2018
/* generate a number of individual electronic circuits - solutions included 
 * 
 * what i made: use LTSpice vector graphic circuit, convert it to svg, replace the values
 * and orientation of current and voltage sources and resistors, simulate this new
 * circuit and present results as svg graphics
 * 
 *  
 * works for current, voltage, res
 * to shuffle orientation, the symbols must be symmetric related to (0,0) 
 * 
 * Modi: helmholz, circuits only, no values, no info at all
 *
 */

// S E T U P 


if (isset($argv[1])) {
    $schematicFilename = $argv[1];
    $OutputDirectory = "./";
} else {
    $schematicFilename = "/home/roland/Dropbox/tmp/x2.asc";
    $OutputDirectory = "/home/roland/Dropbox/tmp/";
} // for debugging only
print_r($argv);
echo $schematicFilename;
//$InputDirectory = "/home/roland/Dropbox/tmp/";
$path_parts = pathinfo($schematicFilename);
$OutputFilename = $path_parts['filename'];
//$LIB = "/home/roland/.wine/drive_c/LTspiceXVII/lib/sym/";
$LIB = "/home/roland/.wine/drive_c/windows/profiles/roland/Eigene Dateien/LTspiceXVII/lib/sym/";
$SCAD3EXE = 'env WINEPREFIX="/home/roland/.wine" wine C:\\\Programme\\\LTC\\\LTspiceXVII\\\XVIIx86.exe ';
$imageMagicConvert = "/usr/bin/convert";  //to produce pdf
$shuffle = true; // random rotation and values 
$AddPointAtPin1 = true;
$Helmholtz = true;
$schematicOnly = false;  //just print out different schematics; or simulation results otherwise
$PAGES = 10;
$VoltMagnitude = 1E2;
$CurrentMagnitude = 1E-2;  // 1E-3 für Milliampere
$ResMagnitude = 1E4;
//error_reporting(E_ALL ^ E_NOTICE);
$filesname = $schematicFilename;


$schematic = array();
$pageWidth = 1024;
$pageHeight = 800;
$extremeLeft;
$extremeTop;
$extremeRight;
$extremeBottom;
$originalSources = array();


if ($Helmholtz) {
    $MAXNUMBEROFSHEETS = 3; // nr of sources + 1
} else {
    $MAXNUMBEROFSHEETS = 1;
}

$s = file_get_contents ($schematicFilename); 
$matches = array();
preg_match('#V/I/R\s*=\s*(.*)/(.*)/(.*)#', $s, $matches);

if (isset($matches[1])) $VoltMagnitude = $matches[1];
if (isset($matches[2])) $CurrentMagnitude = $matches[2];  // 1E-3 für Milliampere
if (isset($matches[3])) $ResMagnitude = $matches[3];

for ($j = 0; $j < $PAGES; $j++) {
    echo " ".($j+1)."/$PAGES "; 
    readSchematic($schematicFilename, $schematic);
    readSymbols($schematic, $symbols);
    insertMissingInfo($schematic, $symbols);

    if ($shuffle)
        shuffleSchematic($schematic);

    for ($i = 0; $i < $MAXNUMBEROFSHEETS; $i++) {

        $finished = false;
        if ($Helmholtz)
            helmholtz($schematic, $i, $finished);
        if ($finished)
            break;
        readSymbols($schematic, $symbols);
        $newSchematicFileName = "schematic.asc";
        $netlistFileName = 'schematic.net';
        WriteNewSchematic($schematic, $symbols, $OutputDirectory . $newSchematicFileName, $i);
        if (!$schematicOnly) {
            createNetlistAndCombineWithSchematic($newSchematicFileName, $schematic);

            //simulate it
            $netlistFn = $netlistFileName;
            $fn1 = "cd $OutputDirectory &&" . "$SCAD3EXE" . ' --ascii -b ' . $netlistFn;
            shell_exec($fn1);

            $simulationresults = array();
            $simulationresults = enterSimulationResults($schematic);
        }



        require_once realpath(dirname(__FILE__)) . "/svglib/svglib.php";
        $svg1 = SVGDocument::getInstance();
        drawSVG($svgA, $pageWidth, $pageHeight, 0, 0, $schematic, $symbols, "original", ($j + 1) . "/" . ($i + 1));
        $svg1->setWidth($pageWidth - 50);
        $pHeight = $extremeBottom - $extremeTop - 50;
        $svg1->setHeight(2 * $pageHeight);
        $svg1->addShape($svgA);

        if (!$schematicOnly) {
            drawSVG($svgB, $pageWidth, $pageHeight, 0, $pageHeight, $schematic, $symbols, "values", ($j + 1) . "/" . ($i + 1));
            $svg1->addShape($svgB);
        }

        $svg1->addScript("style");
        //$svg1->output(); #output to browser, with header
        $svg1->asXML($OutputDirectory . "xxx$i.svg"); //output to svg file
    }
    exec($imageMagicConvert . '   -border 50 -bordercolor "#FFFFFF"  ' . $OutputDirectory . "xxx*.svg $OutputDirectory/$OutputFilename" . "_$j.pdf");
}

function findValue($simulationresults, $name) {
    foreach ($simulationresults as $val) {
        if ($val["name"] == "V($name)") {
            return $val["value"];
        }
    }
}

function drawSVG(&$svg, $pageWidth, $pageHeight, $deltaX, $deltaY, $schematic, $symbols, $mode, $nr) {
    global $extremeLeft;
    global $extremeTop;
    global $extremeRight;
    global $extremeBottom;
    global $LIB;
    global $simulationresults;
    global $AddPointAtPin1;
    global $schematicOnly;
    global $OutputFilename; 
   //////////////////////////////////////////////////////////////////////////////////

    $svg = SVGGroup::getInstance("group1");
    $svg->addAttribute("font-size", 15);
    $svg->addAttribute("font-family", "sans");
    $styl2 = new SVGStyle(array('fill' => 'none', 'stroke' => 'gray', 'stroke-width' => '3'));
    $styl1 = new SVGStyle(array('fill' => 'none', 'stroke' => 'gray', 'stroke-width' => '1'));
    $styl = new SVGStyle(array('fill' => 'blue', 'stroke' => 'gray', 'stroke-width' => '3'));
    $smallFont = new SVGStyle(array('font-size' => '8px'));
    $normalFont = new SVGStyle(array('font-size' => '12px'));
    $largeFont = new SVGStyle(array('font-size' => '15px', 'fill' => 'blue'));
    $normalFontHidden = new SVGStyle(array('class' => 'normalfont_hidden'));


    foreach ($schematic["WIRE"] as $key => $val) {
        addline($svg, $val, 0, 0, 0, 0, 0, $styl);
    }
    foreach ($schematic["FLAG"] as $key => $val) {
        $name = trim($val[3]);
        $x1 = intval($val[1]);
        $y1 = intval($val[2]);
        if ($name != "0") {
            if ($mode != "original")
                $voltage = formatFloat(findValue($simulationresults, $name));
            $text = ($mode == "original") ? $name : $voltage;
            $txt = SVGText::getInstance($x1, $y1 - 2, "f" . $key, $text, "");
            $svg->addShape($txt);
        } else {
            //Masse
            $lineMasse = SVGLine::getInstance($x1 - 10, $y1, $x1 + 10, $y1, $id = "lm" . $key, $style = $styl2);
            $svg->addShape($lineMasse); #add the rect to svg
        }
    }
    foreach ($schematic["ENDPOINTS"] as $key => $val) {
        if ($val >= 3) {
            $xy = explode("|", $key);
            $x = intval($xy[0]);
            $y = intval($xy[1]);
            $c = SVGCircle::getInstance($x, $y, 3, $id = "c", $style = $styl);
            $svg->addShape($c);
        }
    }
    if (!$schematicOnly)
        if (isset($schematic["DATAFLAG"])) {
            if ($mode != "original") {
                foreach ($schematic["DATAFLAG"] as $key => $val) {
                    foreach ($simulationresults as $sim) {
                        $value = trim($val[3], '"');
                        if (stripos($sim["name"], $value) !== false) {
                            $schematic["DATAFLAG"][$key]["value"] = $sim["value"];
                        }
                    }
                    //$txt = $simulationresults[];

                    $x2 = intval($val[1]);
                    $y2 = intval($val[2]);
                    if (!isset($schematic["DATAFLAG"][$key]["value"]))
                        continue;
                    $value = formatFloat($schematic["DATAFLAG"][$key]["value"]);
                    $value3 = trim($schematic["DATAFLAG"][$key][3], '"');
                    if ($value3 == "")
                        continue;
                    if (substr($value3, 0, 1) == "V") {
                        $value .= "V";
                    }
                    if (substr($value3, 0, 1) == "I") {
                        $value .= "A";
                    }
                    //guess the widht of the text

                    addText($svg, $x2, $y2 - 4, 0, 0, 0, $value, "");
                }
            }
        }

    if (isset($schematic["TEXT"])) {
        foreach ($schematic["TEXT"] as $key => $val) {
            $x2 = intval($val[1]);
            $y2 = intval($val[2]);

            $txt = "";
            for ($i = 5; $i < count($val); $i++)
                $txt .= " " . $val[$i];
            $txt = trim($txt);

            $txt = substr($txt, 1, strlen($txt) - 1);
            $zeilen = explode('\n', $txt);
            for ($i = 0; $i < count($zeilen); $i++) {
                $tx = $zeilen[$i];
                addText($svg, $x2 + strlen($tx) * 3, $y2 + ($i) * 16 + 6, 0, 0, 0, $tx, "");
            }
        }
    }
    foreach ($schematic["SYMBOL"] as $key => $val) {
        $offsetx = intval($val[2]);
        $offsety = intval($val[3]);
        $angle = intval(substr($val[4], 1));
        $mirror = (substr($val[4], 0, 1));
        $sym = $symbols[$LIB . $val[1]];

        // Symbole zeichnen

        foreach ($sym["LINE"] as $lineVal) {
            addline($svg, $lineVal, $offsetx, $offsety, $angle, $mirror, 1, $styl);
        }
        if (isset($sym["CIRCLE"]))
            foreach ($sym["CIRCLE"] as $cVal) {
                $offsetx = intval($val[2]);
                $offsety = intval($val[3]);

                addCircle($svg, $cVal, $offsetx, $offsety, $angle, $styl1);
            }

        foreach ($sym["PIN"] as $pVal) {
            $x = intval($pVal[1]);
            $y = intval($pVal[2]);
            $order = $pVal["PINATTR"][2];
            $pin[$order]["x"] = $x;
            $pin[$order]["y"] = $y;
            if (($order == "1") && $AddPointAtPin1) {
                addText($svg, $x, $y + 2, $offsetx, $offsety, $angle, "*", $smallFont);
            }
        }
//        $x1 = $pin[1]["x"];
//        $y1 = $pin[1]["y"];
//        $x2 = $pin[2]["x"];
//        $y2 = $pin[2]["y"];
        // WINDOW (Schreibposition) setzen; Wenn kein WINDOW im Schematic, dann aus dem Symbol holen
        //$symbolname = $val[1];
        //$fn = str_replace("\ ", "\x20", $LIB . $symbolname);
        $attributWindowInstaName = $val["WINDOW"][0]["InstName"];
        if ($mode != "original") {
            $current = formatFloat($val["CURRENT"]);
            $current = $current . "A";
        }
        $attributWindowInstaNameX = $val["WINDOW"][0]["x"];
        $attributWindowInstaNameY = $val["WINDOW"][0]["y"];
        $val2 = ($mode == "original") ? $attributWindowInstaName : $current;
        addText($svg, $attributWindowInstaNameX, $attributWindowInstaNameY, $offsetx, $offsety, $angle, $val2, $largeFont);
        if (isset($val["WINDOW"][3])) {
            $value = $val["WINDOW"][3]["Value"];
            if (!isset($val["NODES"]["NODE1"]["VALUE"])) {
                $val["NODES"]["NODE1"]["VALUE"] = 0;
            }
            $val1 = "";
            if (!isset($val["NODES"]["NODE2"]["VALUE"])) {
                $val["NODES"]["NODE2"]["VALUE"] = 0;
            }
            $voltage = formatFloat($val["NODES"]["NODE1"]["VALUE"] - $val["NODES"]["NODE2"]["VALUE"]);
            $voltage = $voltage . "V";
            $attributWindowValueX = $val["WINDOW"][3]["x"];
            $attributWindowValueY = $val["WINDOW"][3]["y"];
            $val1 = ($mode == "original") ? $value : $voltage;
        }
        addText($svg, $attributWindowValueX, $attributWindowValueY, $offsetx, $offsety, $angle, $val1, $normalFontHidden);
    }

    $pagelength = $extremeRight - $extremeLeft + 100;
    $pageheight = $extremeBottom - $extremeTop + 100;
    $scaleX = $pageWidth / $pagelength;
    $scaleY = $pageHeight / $pageheight;

    $dX = $deltaX * $scaleX - $extremeLeft * $scaleX + 50;
    $dY = $deltaY - $extremeTop * $scaleX + 50;

    $txt = SVGText::getInstance($extremeLeft + 10, $extremeTop + 20, "nr", "Nr.:" . $nr . " $OutputFilename", "styl2");
    $svg->addShape($txt);



    $svg->setAttribute('transform', "translate($dX,$dY) scale($scaleX)");
}

function checkExtremPoints($x, $y) {
    global $extremeLeft;
    global $extremeTop;
    global $extremeRight;
    global $extremeBottom;


    if (!isset($extremeLeft))
        $extremeLeft = $x;
    if (!isset($extremeRight))
        $extremeRight = $x;
    if (!isset($extremeTop))
        $extremeTop = $y;
    if (!isset($extremeBottom))
        $extremeBottom = $y;

    if ($x < $extremeLeft)
        $extremeLeft = $x;
    if ($y < $extremeTop) {
        $extremeTop = $y;
    }
    if ($x > $extremeRight)
        $extremeRight = $x;
    if ($y > $extremeBottom) {
        $extremeBottom = $y;
    }
}

function addline(&$svg, $val, $ox, $oy, $angle, $mirror, $idx, $styl) {
    if ($mirror === "M") {
        //mirror at 0 horizontally
        $x1 = $ox - intval($val[1 + $idx]);
        $y1 = $oy + intval($val[2 + $idx]);
        $x2 = $ox - intval($val[3 + $idx]);
        $y2 = $oy + intval($val[4 + $idx]);
    } else {
        $x1 = $ox + intval($val[1 + $idx]);
        $y1 = $oy + intval($val[2 + $idx]);
        $x2 = $ox + intval($val[3 + $idx]);
        $y2 = $oy + intval($val[4 + $idx]);
    }
    $n = rand(1, 10000);
    $line = SVGLine::getInstance($x1, $y1, $x2, $y2, $id = "l$n", $style = $styl);
    checkExtremPoints($x1, $y1);
    checkExtremPoints($x2, $y2);
    if ($idx == 1) { //symbols only
        $line->rotate($angle, $ox, $oy);
    }
    $svg->addShape($line); #add the rect to svg
}

function addCircle(&$svg, $val, $ox, $oy, $angle, $styl) {
    $x1 = intval($val[2]);
    $y1 = intval($val[3]);
    $x2 = intval($val[4]);
    $y2 = intval($val[5]);

    $circ = SVGCircle::getInstance(($x1 + $x2) / 2 + $ox, ($y1 + $y2) / 2 + $oy, ($y2 - $y1) / 2, $id = "c", $style = $styl);
    $circ->rotate($angle, $ox, $oy);
    $svg->addShape($circ);
}

$id = 0;

function addText(&$svg, $x, $y, $ox, $oy, $angle, $text, $style) {
    global $id;
    global $styl1;
    if (empty($style))
        $style = $styl1;
    // Radius für Rotation

    $r = sqrt(pow($x, 2) + pow($y, 2));
    $ang = GetDegree($x, $y); // 4 Quadrant

    $xx = $r * cos(($ang + $angle) * M_PI / 180.0);
    $yy = $r * sin(($ang + $angle) * M_PI / 180.0);
    $len = strlen($text);
    $xkorr = 0;
    {
        $xkorr = -$len * 3;
    }

    $txt = SVGText::getInstance($xx + $ox + $xkorr, $yy + $oy, "t", $text, $style = $style);
    //$a= $txt->rotate( $ox, $oy);
//    $svg->addShape($txt);
//    $txt->rotate(180, $ox, $oy);
    //$txt->addAttribute("class", "red");
    $txt->addOnClick("this.style");
    $svg->addShape($txt);
}

function GetDegree($x, $y) {
    // we don't want to cause division by zero
    if ($x == 0)
        $x = 1 / 10000;

    $deg = rad2deg(atan(abs($y / $x)));

    if ($y >= 0)
        $deg = $x < 0 ? 180 - $deg : $deg;
    else
        $deg = $x < 0 ? 180 + $deg : 360 - $deg;

    return $deg;
}

function formatFloat($val) {
    $e = "";
    $x = abs(floatval($val));
    if ($x < 1E-9)
        $x = 0;
    else if (($x < 1E-6) && ($x >= 1E-9)) {
        $x = ($x * 1E9);
        $e = "n";
    } else if (($x < 1E-3) && ($x >= 1E-6)) {
        $x = ($x * 1E6);
        $e = "u";
    } else if (($x < 1) && ($x >= 1E-3)) {
        $x = ($x * 1000);
        $e = "m";
    } else if (($x < 1E3) && ($x >= 1E-0)) {
        $x = ($x * 1);
        $e = "";
    } else if (($x >= 1E-3)) {
        $x = ($x / 1000);
        $e = "k";
    }

    $sign = $val < 0 ? -1 : 1;
    $x = round($x * 1000) / 1000;

    return ($sign * $x) . $e;
}

//Trim Netlist
/* LTSpice schreibt, wenn default, die WINDOW Properties nicht in die Netzliste
 * ==> Netzliste neu erzeugen um veränderte Bauteilwerte schreiben zu können
 */
function line($x, $count) {
    $s = "";
    $nr = 0;
    foreach ($x as $val) {
        $s .= $val . " ";
        if ($nr > $count - 2)
            break;
        $nr++;
    }
    $s .= "\n";
    return $s;
}

function WriteNewSchematic($schematic, $symbols, $schematicFileName, $nr) {
    global $LIB;
    global $extremeLeft;
    global $extremeBottom;

    $f = fopen($schematicFileName, "w") or die("Unable to write schematic $schematicFileName");
    fwrite($f, "Version 4\n");
    fwrite($f, line($schematic["SHEET"], 4));
    foreach ($schematic["WIRE"] as $val)
        fwrite($f, line($val, 5));
    foreach ($schematic["FLAG"] as $val)
        fwrite($f, line($val, 4));
//foreach($schematic["TEXT"] as $val) fwrite($f,line($val)); 
    foreach ($schematic["SYMBOL"] as $val) {
        $window = $val["WINDOW"];
        unset($val["WINDOW"]);
        fwrite($f, line($val, 5));
        //reference
        fwrite($f, "WINDOW 0 ");
        fwrite($f, $window[0]["x"] . " ");
        fwrite($f, $window[0]["y"] . " ");
        fwrite($f, $window[0]["direction"] . " ");
        fwrite($f, $window[0]["param"] . "\n");
        //value
        if (isset($window[3])) {
            fwrite($f, "WINDOW 3 ");
            fwrite($f, $window[3]["x"] . " ");
            fwrite($f, $window[3]["y"] . " ");
            fwrite($f, $window[3]["direction"] . " ");
            fwrite($f, $window[3]["param"] . "\n");
            fwrite($f, "SYMATTR InstName " . $window[0]["InstName"] . "\n");

            fwrite($f, "SYMATTR Value " . $window[3]["Value"] . " \n");
        }
    }

    $l = $extremeLeft + 50;
    fwrite($f, "TEXT $extremeLeft $extremeBottom Left 2 !.op \n");
//    fwrite($f, "TEXT $l $extremeBottom Left 2 $nr");


    fclose($f);
}

/*
 * 
 * Problem: wenn im Schaltplan die Default-Werte (Attribut VALUE) der Bauteile verwendet 
 * werden, so werden diese Werte nicht in den Schaltplan .asc eingetragen, sondern 
 * bei Bedarf aus der ibliothek gelesen. Vorteil: man kann mit einer Änderung alle Bauteil-
 * werte abändern Nachteil: will man den Schaltplan .asc manipulieren, dann fehlen diese 
 * Einträge ==> Netzliste umschreiben, so dass alle Attribute eingetragen sind. 
 * 
 * alle Texte werden entfernt und ein .op eingefügts
 * 

 */

function readSchematic($schematicfn, &$schematic) {
    $schematic = array();
    $dn = dirname($schematicfn);
    $fn = basename($schematicfn);
    $myfile = fopen("$dn/$fn", "r") or die("Unable to open schematic $dn/$fn");
    $status = 0;
    $symbolcount = 0;
    while (!feof($myfile)) {
        $line = trim(fgets($myfile));

        if ($line == false)
            continue;

        $line = iconv("ISO-8859-1", "UTF-8", $line);

        $line = str_replace('\ ', '/x', $line);
        $line = str_replace('\\\\', '/', $line);
        $tokens = explode(' ', $line);
        $tokens[1] = str_replace('/x', '\ ', $tokens[1]);

        switch ($tokens[0]) {
            case "SHEET":

                $schematic["SHEET"] = $tokens;
                break;
            case "WIRE":
                $x1 = intval($tokens[1]);
                $y1 = intval($tokens[2]);
                $x2 = intval($tokens[3]);
                $y2 = intval($tokens[4]);
                if (empty($schematic["ENDPOINTS"][$x1 . "|" . $y1]))
                    $schematic["ENDPOINTS"][$x1 . "|" . $y1] = 1;
                else
                    $schematic["ENDPOINTS"][$x1 . "|" . $y1] ++;
                if (empty($schematic["ENDPOINTS"][$x2 . "|" . $y2]))
                    $schematic["ENDPOINTS"][$x2 . "|" . $y2] = 1;
                else
                    $schematic["ENDPOINTS"][$x2 . "|" . $y2] ++;
                $schematic["WIRE"][] = $tokens;
                break;
            case "FLAG":
                $schematic["FLAG"][] = $tokens;
                break;
            case "DATAFLAG":
                $schematic["DATAFLAG"][] = $tokens;
                break;
            case "TEXT":
                $schematic["TEXT"][] = $tokens;
                break;
            case "SYMBOL":
                $schematic["SYMBOL"][$symbolcount] = $tokens;

                $symbolcount++;
                break;
            case "SYMATTR":
                //$schematic["SYMBOL"][$symbolcount - 1]["SYMATTR"][] = $tokens;
                $type = $tokens[1];
                if ($type == "Value")
                    $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][3]["Value"] = $tokens[2];
                if ($type == "InstName")
                    $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][0]["InstName"] = $tokens[2];
                break;
            case "WINDOW":
                $id = intval($tokens[1]);
                $x1 = intval($tokens[2]);
                $y1 = intval($tokens[3]);

                $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][$id]["x"] = $x1;
                $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][$id]["y"] = $y1;
                $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][$id]["direction"] = $tokens[4];
                $schematic["SYMBOL"][$symbolcount - 1]["WINDOW"][$id]["param"] = $tokens[5];
                break;
        }
    }
    fclose($myfile);
}

function readSymbols(&$schematic, &$symbols) {
    global $LIB;
    foreach ($schematic["SYMBOL"] as $key => $val) {
        $windowcount = 0;
        $pincount = 0;
        $fn = str_replace("\ ", "\x20", $LIB . $val[1]);
        $myfile = fopen(realpath($fn . ".asy"), "r") or die("Unable to open symbol file!" . $fn);
        while (!feof($myfile)) {
            $line = trim(fgets($myfile));
            $line = iconv("ISO-8859-1", "UTF-8", $line);

            $tokens = explode(' ', $line);
            switch ($tokens[0]) {
                case "LINE":
                    $symbols[$fn]["LINE"][] = $tokens;
                    break;
                case "CIRCLE":
                    $symbols[$fn]["CIRCLE"][] = $tokens;
                    break;
                case "WINDOW":
                    $id = intval($tokens[1]);
                    $x1 = intval($tokens[2]);
                    $y1 = intval($tokens[3]);
                    $direction = ($tokens[4]);
                    $param = ($tokens[5]);
                    $symbols[$fn]["WINDOW"][$id]["x"] = $x1;
                    $symbols[$fn]["WINDOW"][$id]["y"] = $y1;
                    $symbols[$fn]["WINDOW"][$id]["direction"] = $direction;
                    $symbols[$fn]["WINDOW"][$id]["param"] = $param;
                    break;
                case "SYMATTR":
                    $type = $tokens[1];
                    if ($type == "Value")
                        $symbols[$fn]["WINDOW"][3]["Value"] = $tokens[2];
                    if ($type == "Prefix")
                        $symbols[$fn]["WINDOW"][0]["Prefix"] = $tokens[2];
                    break;
                case "PIN":
                    $symbols[$fn]["PIN"][$pincount++] = $tokens;
                    break;
                case "PINATTR":
                    $symbols[$fn]["PIN"][$pincount - 1]["PINATTR"] = $tokens;
                    break;
            }
        }
        fclose($myfile);
    }
}

////////////////////////////////////////////////////////////////////////////////
// Insert missing Window and Pinattrib entries into schematic .asc            //
////////////////////////////////////////////////////////////////////////////////
function insertMissingInfo(&$schematic, &$symbols) {
    global $LIB;
    foreach ($schematic["SYMBOL"] as $key => $val) {
        $symbolname = str_replace("\ ", "\x20", $LIB . $val[1]);
        $value0 = $symbols[$symbolname]["WINDOW"][0];

        //Reference
        if (!isset($val["WINDOW"][0]["x"])) {
            $schematic["SYMBOL"][$key]["WINDOW"][0]["x"] = $value0["x"];
            $schematic["SYMBOL"][$key]["WINDOW"][0]["y"] = $value0["y"];
            $schematic["SYMBOL"][$key]["WINDOW"][0]["direction"] = $value0["direction"];
            $schematic["SYMBOL"][$key]["WINDOW"][0]["param"] = $value0["param"];
        }
        //Value
        if (isset($symbols[$symbolname]["WINDOW"][3])) {
            $value3 = $symbols[$symbolname]["WINDOW"][3];
        } else
            continue;
        if (!isset($val["WINDOW"][3]["Value"])) {
            $schematic["SYMBOL"][$key]["WINDOW"][3]["Value"] = $value3["Value"];
        }
        if (!isset($schematic["SYMBOL"][$key]["WINDOW"][3]["x"])) {
            $schematic["SYMBOL"][$key]["WINDOW"][3]["x"] = $value3["x"];
            $schematic["SYMBOL"][$key]["WINDOW"][3]["y"] = $value3["y"];
            $schematic["SYMBOL"][$key]["WINDOW"][3]["direction"] = $value3["direction"];
            $schematic["SYMBOL"][$key]["WINDOW"][3]["param"] = $value3["param"];
        }
    }
}

function enterSimulationResults(&$schematic) {
    global $OutputDirectory;
    $rawfn = $OutputDirectory . "schematic.raw";

///// Read RAW Simulation Results
    $myRaw = fopen($rawfn, "r") or die("Unable to open rawfile!");
    $results = array();
    $vars = false;
    $vals = false;
    while (!feof($myRaw)) {
        $line = strtoupper(fgets($myRaw));
        if ($line == "")
            continue;
        $items = preg_split("/[\s]+/", $line);
        if (substr($items[0], 0, 7) == "VALUES:") {
            $vals = true;
            $vars = false;
            $valNr = 0;
            continue;
        }
        if (substr($items[0], 0, 10) == "VARIABLES:") {
            $vars = true;
            $vals = false;
            continue;
        }
        if (!$vars & !$vals)
            continue;
        if ($vars) {
            $results[$items[1]]["name"] = $items[2];
            $results[$items[1]]["type"] = $items[3];
        }

        if (!$vals)
            continue;
        if ($vals) {
            $results[$valNr++]["value"] = $items[1];
        }
    }

// Enter results into schematic
    foreach ($results as $resultVal) {
        $name = $resultVal["name"];
        $nodeName = substr($name, 2, strlen($name) - 3);
        if ($resultVal["type"] == "VOLTAGE") {
            //search schematic for this node and enter its value
            foreach ($schematic["SYMBOL"] as $symbKey => $symb) {
                foreach ($symb["NODES"] as $nodekey => $val) {
                    if ($val["NAME"] == $nodeName) {
                        $res = $resultVal["value"];
                        $schematic["SYMBOL"][$symbKey]["NODES"][$nodekey]["VALUE"] = $res;
                    }
                }
            }
        } else {
            //device_current    
            foreach ($schematic["SYMBOL"] as $symbKey => $symb) {
                if ($symb["WINDOW"][0]["InstName"] == "$nodeName") {
                    $schematic["SYMBOL"][$symbKey]["CURRENT"] = $resultVal["value"];
                }
            }
        }
    }

    return $results;
}

function createNetlistAndCombineWithSchematic($schematicFileName, &$schematic) {
    global $OutputDirectory;
    global $SCAD3EXE;
    $netlistfn = $OutputDirectory . "schematic.net";
    $exefn = "$SCAD3EXE" . ' -netlist  ' . $OutputDirectory . $schematicFileName;
    $x = shell_exec($exefn);
// read netlist
    $myNetlist = fopen($netlistfn, "r") or die("Unable to open netlist!");
    $netlist = array();
    while (!feof($myNetlist)) {
        $line = trim(fgets($myNetlist));
        $items = explode(" ", $line);

        $netlist[$items[0]] = $items;
    }

    $lines = file($netlistfn);
    $nl = fopen($netlistfn, "w") or die("Unable to open netlist for writing!");
    foreach ($lines as $val1) {
        if ($val1 == ".backanno\xD\n") {
            fwrite($nl, ".op\n");
        } else {
            fwrite($nl, $val1);
        }
    }
    fclose($nl);
// Combine Netlist and Schematic
    foreach ($schematic["SYMBOL"] as $key => $val) {
        $instname = $schematic["SYMBOL"][$key]["WINDOW"][0]["InstName"];
        $schematic["SYMBOL"][$key]["NODES"]["NODE1"]["NAME"] = $netlist[$instname][1];
        $schematic["SYMBOL"][$key]["NODES"]["NODE2"]["NAME"] = $netlist[$instname][2];
    }
}

function shuffleSchematic(&$schematic) {
    global $CurrentMagnitude;
    global $VoltMagnitude;
    global $ResMagnitude;
    foreach ($schematic["SYMBOL"] as $key => $symb) {


        if ($symb[1] == "kner/current") {
            if (rand(0, 1) == 1) {
                $symb[1] = "kner/voltage";
                $schematic["SYMBOL"][$key][1] = "kner/voltage";
                $schematic["SYMBOL"][$key]["WINDOW"][0]["InstName"] = "V10";
            }
            // $new_type = (rand(0, 1) == 1) ? "kner/voltage" : "kner/current";
            //$schematic["SYMBOL"][$key][1] = $new_type;
        } else if ($symb[1] == "kner/voltage") {
            if (rand(0, 1) == 1) {
                $symb[1] = "kner/current";
                $schematic["SYMBOL"][$key][1] = "kner/current";
                //$val = round((rand(1, 10) / $CurrentMagnitude) * $CurrentMagnitude) / $CurrentMagnitude;
                $schematic["SYMBOL"][$key]["WINDOW"][0]["InstName"] = "I10";
            }
            // $new_type = (rand(0, 1) == 1) ? "kner/voltage" : "kner/current";
            //$schematic["SYMBOL"][$key][1] = $new_type;
        }
        //if ($type == "kner/voltage") {
        //$new_type = (rand(0, 1) == 1) ? "kner/voltage" : "kner/current";
        //$schematic["SYMBOL"][$key][1] = $new_type;
        //}

        if ($symb[1] == "kner/res") {
            $val = rand(1, 9) * $ResMagnitude;
            $schematic["SYMBOL"][$key]["WINDOW"][3]["Value"] = formatFloat($val);
        }

        if ($symb[1] == "kner/voltage") {
            $val = rand(1, 9) * $VoltMagnitude;
            $schematic["SYMBOL"][$key]["WINDOW"][3]["Value"] = formatFloat($val) . "V";
        }
        if ($symb[1] == "kner/current") {
            $val = rand(1, 9) * $CurrentMagnitude;
            $schematic["SYMBOL"][$key]["WINDOW"][3]["Value"] = formatFloat($val) . "A";
        }
        $orientation = $symb[4];
        $new_orientation = "R0";
        if (($orientation == "R0") || ($orientation == "R180")) {
            $new_orientation = (rand(0, 1) == 1) ? "R0" : "R180";
        }
        if (($orientation == "R90") || ($orientation == "R270")) {
            $new_orientation = (rand(0, 1) == 1) ? "R90" : "R270";
        }
        $schematic["SYMBOL"][$key][4] = $new_orientation;
    }
}

function findSources($symbols) {
    $found = array();
    $nr = 0;
    foreach ($symbols as $key => $val) {
        if ((stripos($val[1], "voltage") !== false) || (stripos($val[1], "current") !== false)) {
            $found[$nr]["index"] = $key;
            $found[$nr]["type"] = $val["1"];
            $found[$nr]["value"] = $val["WINDOW"][3]["Value"];
            $nr++;
        }
    }
    echo "This schematic contains $nr Sources\n";
    return $found;
}

function helmholtz(&$schematic, $nr, &$finished) {
    // Nummer 0 ==> Original
    // Nummer 1 ==> nur Quelle 1 aktiv usw.      
    global $originalSources;
    if ($nr == 0) {
        $originalSources = findSources($schematic["SYMBOL"]);
        return;
    }
    if (!isset($originalSources[$nr - 1])) {
        $finished = true;
        return;
    }
    foreach ($originalSources as $symbolnr => $symbolval) {
        $type = $symbolval["type"];
        if (stripos($type, "voltage") !== false) {
            $new_type = (($nr - 1) == $symbolnr) ? "kner/voltage" : "kner/voltage_inactive";
            $schematic["SYMBOL"][$symbolval["index"]][1] = $new_type;
            $new_value = (($nr - 1) == $symbolnr) ? $symbolval["value"] : 0;
            $schematic["SYMBOL"][$symbolval["index"]]["WINDOW"][3]["Value"] = $new_value;
        }
        if (stripos($type, "current") !== false) {
            $new_type = (($nr - 1) == $symbolnr) ? "kner/current" : "kner/current_inactive";
            $schematic["SYMBOL"][$symbolval["index"]][1] = $new_type;
            $new_value = (($nr - 1) == $symbolnr) ? $symbolval["value"] : 0;
            $schematic["SYMBOL"][$symbolval["index"]]["WINDOW"][3]["Value"] = $new_value;
        }
    }
}

//
//
//Create Circuit and Symbol Files and put them into the proper Dirs
//
//Symbols are special: they are symmetric with respect to the Origin - so it is 
//possible to rotate them randomly ...
//<pre>
//
//#TEST CIRCUIT
//Version 4
//SHEET 1 880 680
//WIRE 608 -16 -96 -16
//WIRE -16 48 -32 48
//WIRE 48 48 -16 48
//WIRE 240 48 48 48
//WIRE 256 48 240 48
//WIRE 288 48 256 48
//WIRE 400 48 384 48
//WIRE 496 48 400 48
//WIRE 528 48 496 48
//WIRE -32 112 -32 48
//WIRE 256 112 256 48
//WIRE 48 128 48 48
//WIRE 400 128 400 48
//WIRE -32 256 -32 208
//WIRE 48 256 48 224
//WIRE 48 256 -32 256
//WIRE 256 256 256 208
//WIRE 256 256 48 256
//WIRE 400 256 400 224
//WIRE 400 256 256 256
//WIRE 528 256 528 240
//WIRE 528 256 400 256
//WIRE -32 272 -32 256
//WIRE -96 336 -96 -16
//WIRE 608 336 608 -16
//WIRE 608 336 -96 336
//FLAG -32 272 0
//DATAFLAG -16 48 ""
//DATAFLAG 240 48 ""
//DATAFLAG 496 48 ""
//SYMBOL voltage 528 192 R0
//WINDOW 0 27 -41 Left 2
//SYMATTR InstName V1
//SYMATTR Value 1V
//SYMBOL res 336 48 R90
//WINDOW 0 -18 -6 VBottom 2
//WINDOW 3 18 -5 VTop 2
//SYMATTR InstName R2
//SYMBOL res -32 160 R180
//WINDOW 0 22 9 Left 2
//WINDOW 3 26 -19 Left 2
//SYMATTR InstName R3
//SYMBOL current 256 160 R180
//WINDOW 0 11 50 Left 2
//WINDOW 3 9 -51 Left 2
//SYMATTR InstName I2
//SYMATTR Value 1mA
//SYMBOL current 48 176 R180
//WINDOW 0 -39 -15 Left 2
//WINDOW 3 -47 10 Left 2
//SYMATTR InstName I3
//SYMATTR Value 1mA
//SYMBOL res 528 96 R0
//WINDOW 0 21 -15 Left 2
//WINDOW 3 20 15 Left 2
//SYMATTR InstName R4
//SYMBOL res 400 176 R0
//WINDOW 0 31 -20 Left 2
//WINDOW 3 32 5 Left 2
//SYMATTR InstName R5
//TEXT -80 296 Left 2 !.op
//
//#VOLTAGE 
//Version 4
//SymbolType CELL
//LINE Normal -23 -41 -7 -41
//LINE Normal -15 -49 -15 -33
//LINE Normal 0 48 0 40
//LINE Normal 0 -48 0 -40
//LINE Normal 0 -33 0 -40
//LINE Normal 0 31 0 40
//LINE Normal 0 31 0 -33
//CIRCLE Normal -32 -33 32 31
//WINDOW 0 31 -37 Left 2
//WINDOW 3 24 39 Left 2
//SYMATTR Value V
//SYMATTR Prefix V
//SYMATTR Description Voltage Source, either DC, AC, PULSE, SINE, PWL, EXP, or SFFM
//PIN 0 -48 NONE 0
//PINATTR PinName +
//PINATTR SpiceOrder 1
//PIN 0 48 NONE 0
//PINATTR PinName -
//PINATTR SpiceOrder 2
//
//
//
//#VOLTAGE INACTIVE 
//Version 4
//SymbolType CELL
//LINE Normal 0 -48 0 48
//WINDOW 0 21 -47 Left 2
//WINDOW 3 25 31 Left 2
//SYMATTR Value 0
//SYMATTR Prefix V
//SYMATTR Description Voltage Source, either DC, AC, PULSE, SINE, PWL, EXP, or SFFM
//PIN 0 -48 NONE 0
//PINATTR PinName +
//PINATTR SpiceOrder 1
//PIN 0 48 NONE 0
//PINATTR PinName -
//PINATTR SpiceOrder 2
//
//#CURRENT SOURCE
//Version 4
//SymbolType CELL
//LINE Normal 0 48 0 40
//LINE Normal 0 -48 0 -40
//LINE Normal 0 -33 0 -40
//LINE Normal 0 40 0 31
//LINE Normal -32 0 32 0
//LINE Normal 0 -7 0 -28
//LINE Normal -4 -17 0 -7
//LINE Normal 4 -17 -4 -17
//LINE Normal 0 -7 4 -17
//CIRCLE Normal -32 -33 32 31
//WINDOW 0 17 -38 Left 2
//WINDOW 3 23 30 Left 2
//SYMATTR Value I
//SYMATTR Prefix I
//PIN 0 -48 NONE 0
//PINATTR PinName +
//PINATTR SpiceOrder 1
//PIN 0 48 NONE 0
//PINATTR PinName -
//PINATTR SpiceOrder 2
//
//
//#CURRENT INACTIVE
//Version 4
//SymbolType CELL
//LINE Normal 0 48 0 32
//LINE Normal 0 -48 0 -32
//LINE Normal -23 0 25 0
//WINDOW 0 24 -48 Left 2
//WINDOW 3 25 32 Left 2
//SYMATTR Value 0
//SYMATTR Prefix I
//SYMATTR Description inactive Current source 
//PIN 0 -48 NONE 0
//PINATTR PinName +
//PINATTR SpiceOrder 1
//PIN 0 48 NONE 0
//PINATTR PinName -
//PINATTR SpiceOrder 2
//
//
//
//# RESISTOR
//Version 4
//SymbolType CELL
//LINE Normal 0 32 0 48
//LINE Normal 0 -48 0 -38
//LINE Normal 11 -40 -11 -40
//LINE Normal 11 -39 -11 -39
//LINE Normal 11 -38 -11 -38
//LINE Normal -11 32 -11 -40
//LINE Normal 11 -40 11 32
//LINE Normal 11 32 -11 32
//WINDOW 0 17 -14 Left 2
//WINDOW 3 17 5 Left 2
//SYMATTR Value 1k
//SYMATTR Prefix R
//SYMATTR Description A Resistor(European style graphic)
//PIN 0 -48 NONE 0
//PINATTR PinName A
//PINATTR SpiceOrder 1
//PIN 0 48 NONE 0
//PINATTR PinName B
//PINATTR SpiceOrder 2
//
//
